## rock-master-20.06-tools-graph-analysis 0.20200505

=== CMakeLists.txt ===
# CMakeLists.txt has to be located in the project folder and cmake has to be
# executed from 'project/build' with 'cmake ../'.
cmake_minimum_required(VERSION 3.1)
find_package(Rock)
# Currently requires RelWithDebInfo at minimum to build with lemon
set(CMAKE_BUILD_TYPE RelWithDebInfo)
# Required for graphviz
add_definitions(-DHAVE_STRING_H)
add_definitions(-Wall -g)
add_definitions(-DNUMERIC_DEPRECATE=1)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
rock_init(graph_analysis 0.3)
rock_standard_layout()

if(NOT TARGET graph_analysis_py)
    add_subdirectory(bindings/python)
endif()

install(DIRECTORY resources/icons
        DESTINATION share/graph_analysis/)

=== src/CMakeLists.txt ===
find_package(Boost REQUIRED filesystem system serialization)
find_package(SCIP)

if(EMBED_GLPK)
    add_definitions(-DEMBED_GLPK)
    list(APPEND EXTRA_HPP
            algorithms/lp/embedded/GLPKSolver.hpp
            algorithms/CorrelationClustering.hpp
    )
    list(APPEND EXTRA_CPP
        algorithms/lp/embedded/GLPKSolver.cpp
        algorithms/CorrelationClustering.cpp
    )
endif()

if(EMBED_SCIP)
if(SCIP_FOUND)
    list(APPEND EXTRA_HPP
            algorithms/lp/embedded/ScipSolver.hpp
            algorithms/lp/embedded/SoplexSolver.hpp
    )
    list(APPEND EXTRA_CPP
        algorithms/lp/embedded/ScipSolver.cpp
        algorithms/lp/embedded/SoplexSolver.cpp
    )

    add_definitions(-DWITH_SCIP)
else(SCIP_FOUND)
    message(STATUS "Embedding SCIP requested, but library is not installed")
endif(SCIP_FOUND)
endif(EMBED_SCIP)

rock_library(graph_analysis
    SOURCES
        Attribute.cpp
        AttributeManager.cpp
        BaseGraph.cpp
        BipartiteGraph.cpp
        DirectedHyperEdge.cpp
        Edge.cpp
        EdgeIterable.cpp
        EdgeIterator.cpp
        EdgeTypeManager.cpp
        Filter.cpp
        GraphElement.cpp
        GraphIO.cpp
        HyperEdge.cpp
        Percolation.cpp
        SubGraph.cpp
        Vertex.cpp
        VertexIterable.cpp
        VertexIterator.cpp
        VertexTypeManager.cpp
        TransactionObserver.cpp
        algorithms/BFS.cpp
        algorithms/ConstraintViolation.cpp
        algorithms/DFS.cpp
        algorithms/FloydWarshall.cpp
        algorithms/lp/Problem.cpp
        algorithms/lp/Solution.cpp
        algorithms/LPSolver.cpp
        algorithms/lp/CBCSolver.cpp
        algorithms/lp/CLPSolver.cpp
        algorithms/lp/CommandlineSolver.cpp
        algorithms/lp/GLPKSolver.cpp
        algorithms/lp/ScipSolver.cpp
        algorithms/MinCostFlow.cpp
        algorithms/MultiCommodityEdge.cpp
        algorithms/MultiCommodityMinCostFlow.cpp
        algorithms/MultiCommodityVertex.cpp
        algorithms/Visitor.cpp
        boost_graph/DirectedGraph.cpp
        boost_graph/DirectedSubGraph.cpp
        filters/EdgeContextFilter.cpp
        filters/RegexFilters.cpp
        gui/ActionCommander.cpp
        gui/BaseGraphView/AddEdgeDialog.cpp
        gui/BaseGraphView/AddVertexDialog.cpp
        gui/BaseGraphView/BaseGraphView.cpp
        gui/EdgeItemBase.cpp
        gui/EdgeItemSimple.cpp
        gui/EdgeItemTypeManager.cpp
        gui/EdgeMimeData.cpp
        gui/FilterItem.cpp
        gui/FilterManager.cpp
        gui/GraphAnalysisGui.cpp
        gui/GraphLayout.cpp
        gui/GraphLayoutManager.cpp
        gui/GraphWidget.cpp
        gui/GraphWidgetManager.cpp
        gui/IconManager.cpp
        gui/VertexItemTypeManager.cpp
        gui/Player.cpp
        gui/PlayerConfiguration.cpp
        gui/QBaseGraph.cpp
        gui/VertexItemBase.cpp
        gui/VertexItemSimple.cpp
        gui/WidgetManager.cpp
        gui/dialogs/AddFilterDialog.cpp
        gui/dialogs/AddGraphElement.cpp
        gui/dialogs/CustomDialog.cpp
        gui/dialogs/GridLayout.cpp
        gui/dialogs/IODialog.cpp
        gui/dialogs/RenameFilterDialog.cpp
        gui/dialogs/SwapFiltersDialog.cpp
        gui/items/Feature.cpp
        gui/items/Label.cpp
        gui/layouts/GVLayout.cpp
        gui/layouts/GridLayout.cpp
        io/GVGraph.cpp
        io/GexfReader.cpp
        io/GexfWriter.cpp
        io/GraphMLReader.cpp
        io/GraphMLWriter.cpp
        io/GraphvizGridStyle.cpp
        io/GraphvizWriter.cpp
        io/YamlReader.cpp
        io/YamlWriter.cpp
        lemon/DirectedGraph.cpp
        lemon/DirectedSubGraph.cpp
        percolation/Event.cpp
        percolation/RandomNumberGenerator.cpp
        percolation/strategies/RandomDraw.cpp
        percolation/strategies/UniformRandomEdgeRemoval.cpp
        percolation/strategies/UniformRandomVertexRemoval.cpp
        snap/DirectedGraph.cpp
        snap/DirectedSubGraph.cpp
        utils/MD5.cpp
        utils/Filesystem.cpp
        ${EXTRA_CPP}
    HEADERS
        Attribute.hpp
        AttributeManager.hpp
        Algorithms.hpp
        BaseGraph.hpp
        BaseGraphObserver.hpp
        TransactionObserver.hpp
        BaseIterable.hpp
        BipartiteGraph.hpp
        DirectedGraphInterface.hpp
        DirectedHyperEdge.hpp
        Edge.hpp
        EdgeIterable.hpp
        EdgeIterator.hpp
        EdgeRegistration.hpp
        EdgeTypeManager.hpp
        Filter.hpp
        Graph.hpp
        GraphAnalysis.hpp
        GraphElement.hpp
        GraphIO.hpp
        HyperEdge.hpp
        NWeighted.hpp
        NWeightedEdge.hpp
        NWeightedVertex.hpp
        Percolation.hpp
        SharedPtr.hpp
        SubGraph.hpp
        SubGraphImpl.hpp
        TypedGraph.hpp
        Vertex.hpp
        VertexIterable.hpp
        VertexIterator.hpp
        VertexRegistration.hpp
        VertexTypeManager.hpp
        WeightedEdge.hpp
        WeightedVertex.hpp
        algorithms/BFS.hpp
        algorithms/BFSVisitor.hpp
        algorithms/ConstraintViolation.hpp
        algorithms/DistanceMatrix.hpp
        algorithms/DFS.hpp
        algorithms/DFSVisitor.hpp
        algorithms/FloydWarshall.hpp
        algorithms/lp/Problem.hpp
        algorithms/lp/Solution.hpp
        algorithms/LPSolver.hpp
        algorithms/lp/CBCSolver.hpp
        algorithms/lp/CLPSolver.hpp
        algorithms/lp/CommandlineSolver.hpp
        algorithms/lp/GLPKSolver.hpp
        algorithms/lp/ScipSolver.hpp
        algorithms/MinCostFlow.hpp
        algorithms/MultiCommodityEdge.hpp
        algorithms/MultiCommodityMinCostFlow.hpp
        algorithms/MultiCommodityVertex.hpp
        algorithms/Skipper.hpp
        algorithms/Visitor.hpp
        boost_graph/DirectedGraph.hpp
        boost_graph/DirectedSubGraph.hpp
        filters/CommonFilters.hpp
        filters/EdgeContextFilter.hpp
        filters/RegexFilters.hpp
        gui/ActionCommander.hpp
        gui/BaseGraphView/AddEdgeDialog.hpp
        gui/BaseGraphView/AddVertexDialog.hpp
        gui/BaseGraphView/BaseGraphView.hpp
        gui/EdgeItemBase.hpp
        gui/EdgeItemSimple.hpp
        gui/EdgeItemTypeManager.hpp
        gui/EdgeMimeData.hpp
        gui/FilterItem.hpp
        gui/FilterManager.hpp
        gui/GraphAnalysisGui.hpp
        gui/GraphLayout.hpp
        gui/GraphLayoutManager.hpp
        gui/GraphWidget.hpp
        gui/GraphWidgetManager.hpp
        gui/GraphicsItemTypes.hpp
        gui/IconManager.hpp
        gui/VertexItemTypeManager.hpp
        gui/Player.hpp
        gui/PlayerConfiguration.hpp
        gui/QBaseGraph.hpp
        gui/RegisterQtMetatypes.hpp
        gui/VertexItemBase.hpp
        gui/VertexItemSimple.hpp
        gui/WidgetManager.hpp
        gui/dialogs/AddFilterDialog.hpp
        gui/dialogs/AddGraphElement.hpp
        gui/dialogs/CustomDialog.hpp
        gui/dialogs/GridLayout.hpp
        gui/dialogs/IODialog.hpp
        gui/dialogs/RenameFilterDialog.hpp
        gui/dialogs/SwapFiltersDialog.hpp
        gui/items/Feature.hpp
        gui/items/Label.hpp
        gui/layouts/GVLayout.hpp
        gui/layouts/GridLayout.hpp
        io/GVGraph.hpp
        io/GexfReader.hpp
        io/GexfWriter.hpp
        io/GraphMLReader.hpp
        io/GraphMLWriter.hpp
        io/GraphvizStyle.hpp
        io/GraphvizGridStyle.hpp
        io/GraphvizWriter.hpp
        io/Serialization.hpp
        io/YamlReader.hpp
        io/YamlWriter.hpp
        lemon/ArcIterator.hpp
        lemon/DirectedGraph.hpp
        lemon/DirectedSubGraph.hpp
        lemon/Graph.hpp
        lemon/NodeIterator.hpp
        percolation/Event.hpp
        percolation/RandomNumberGenerator.hpp
        percolation/strategies/RandomDraw.hpp
        percolation/strategies/UniformRandomEdgeRemoval.hpp
        percolation/strategies/UniformRandomVertexRemoval.hpp
        snap/DirectedGraph.hpp
        snap/DirectedSubGraph.hpp
        snap/EdgeIterator.hpp
        snap/Graph.hpp
        snap/NodeIterator.hpp
        utils/MD5.hpp
        utils/Filesystem.hpp
        ${EXTRA_HPP}
    DEPS_PKGCONFIG
        lemon snap base-lib gexf numeric libgvc utilmm yaml-cpp
    DEPS_PLAIN
        Boost_SERIALIZATION
        Boost_FILESYSTEM
    MOC
        gui/GraphAnalysisGui.hpp
        gui/QBaseGraph.hpp
        gui/FilterManager.hpp
        gui/GraphWidget.hpp
        gui/GraphWidgetManager.hpp
        gui/dialogs/AddFilterDialog.hpp
        gui/dialogs/AddGraphElement.hpp
        gui/dialogs/GridLayout.hpp
        gui/dialogs/RenameFilterDialog.hpp
        gui/dialogs/SwapFiltersDialog.hpp
        gui/BaseGraphView/BaseGraphView.hpp
        gui/BaseGraphView/AddVertexDialog.hpp
        gui/BaseGraphView/AddEdgeDialog.hpp
        gui/Player.hpp
    DEPS_PKGCONFIG QtGui QtSvg
    UI
        gui/GraphAnalysisGui.ui
        gui/BaseGraphView/AddVertexDialog.ui
        gui/BaseGraphView/AddEdgeDialog.ui
        gui/dialogs/add_filter_dialog_gui.ui
        gui/dialogs/add_graph_element.ui
        gui/dialogs/graph_analysis_gui.ui
        gui/dialogs/grid_layout.ui
        gui/dialogs/property_dialog_gui.ui
        gui/dialogs/swap_filters_dialog_gui.ui
)
target_link_libraries(graph_analysis cgraph gomp)

if(EMBED_GLPK)
    target_link_libraries(graph_analysis glpk)
endif(EMBED_GLPK)

if(EMBED_SCIP)
if(SCIP_FOUND)
    message(STATUS "Linking SCIP Library: ${SCIP_LIBRARIES}")
    target_link_libraries(graph_analysis ${SCIP_LIBRARIES})
endif()
endif()

get_target_property(graph_analysis-linker_flags graph_analysis LINK_FLAGS)
if(graph_analysis-linker_flags)
    set(graph_analysis-linker_flags "${graph_analysis-linker_flags} -Wl,--exclude-libs=libsnap.a" )
else()
    set(graph_analysis-linker_flags "-Wl,--exclude-libs=libsnap.a" )
endif()
set_target_properties(graph_analysis PROPERTIES LINK_FLAGS ${graph_analysis-linker_flags})

rock_executable(graph_analysis-bm Benchmark.cpp
    DEPS graph_analysis
    DEPS_PLAIN rt
        Boost_FILESYSTEM
        Boost_SYSTEM
    NOINSTALL)

rock_executable(graph_analysis-gui gui/main.cpp
    DEPS graph_analysis
    )

rock_executable(graph_analysis-reader utils/GraphReaderMain.cpp
    DEPS graph_analysis
    )

=== test/CMakeLists.txt ===
if(EMBED_GLPK)
    list(APPEND EXTRA_TEST_CPP
        algorithms/test_CorrelationClustering.cpp
    )
endif()

rock_testsuite(graph_analysis-test
    suite.cpp
    test_EdgesVertices.cpp
    test_Observer.cpp
    test_Filters.cpp
    test_Graph.cpp
    test_GraphElement.cpp
    test_SubGraph.cpp
    test_Percolation.cpp
    test_GraphIO.cpp
    test_GVGraph.cpp
    test_Iterators.cpp
    test_Utils.cpp
    algorithms/test_Algorithms.cpp
    algorithms/test_BFS.cpp
    algorithms/test_DFS.cpp
    algorithms/test_FloydWarshall.cpp
    algorithms/test_MinCostFlow.cpp
    algorithms/test_MultiCommodityMinCostFlow.cpp
    algorithms/test_LPSolver.cpp
    algorithms/test_LPProblem.cpp
    ${EXTRA_TEST_CPP}
    DEPS graph_analysis)

=== bindings/python/CMakeLists.txt ===
if(PYTHON_EXECUTABLE)
    message(STATUS "Defined python executable is: ${PYTHON_EXECUTABLE}")
    set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
elseif("$ENV{PYTHON}" STREQUAL "")
    # https://cmake.org/cmake/help/v3.12/module/FindPython.html
    find_package(Python COMPONENTS Interpreter)
else()
    set(PYTHON $ENV{PYTHON})
    message(STATUS ${PYTHON})
endif()

if("$ENV{CYTHON}" STREQUAL "")
    find_program(CYTHON
        NAMES cython3 cython
    )
else()
    set(CYTHON $ENV{CYTHON})
    message(STATUS ${CYTHON})
endif()

set(EXT_FILES
        _graph_analysis.pxd
        graph_analysis.pyx
)

if(CYTHON)
    message(STATUS "Using python: ${Python_EXECUTABLE}")
    message(STATUS "Using cython: ${CYTHON}")

    configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in"
    "${CMAKE_CURRENT_BINARY_DIR}/setup.py")

    add_custom_target(graph_analysis_py-prepare)
    foreach(file ${EXT_FILES})
        add_custom_command(TARGET graph_analysis_py-prepare PRE_BUILD
            # Preserve the timestamp with -p so that setup.py only rebuilds
            # when files have changed
            COMMAND cp -p ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}
        )
    endforeach()

    # Custom python target that runs 'setup.py build' to build all python
    # components.
    option(PYTHON_SUPPORT "Build and install python wrapper" ON)
    if (PYTHON_SUPPORT)
        set(SETUP_PY "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
        message(STATUS "Building python extension with setup.py: ${SETUP_PY}")

        add_custom_target(graph_analysis_py ALL DEPENDS graph_analysis graph_analysis_py-prepare
            COMMAND echo "Building extensions"
            COMMAND ${Python_EXECUTABLE} ${SETUP_PY} build
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )

        add_custom_target(pyext-clean
            COMMAND ${Python_EXECUTABLE} ${SETUP_PY} clean
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            )

        install(
          CODE "execute_process(
            COMMAND ${Python_EXECUTABLE} ${SETUP_PY} install --prefix=${CMAKE_INSTALL_PREFIX}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})"
        )

        # nose is the python unit testing program it will run all python unit tests
        find_program(NOSETEST NAMES nosetests3)
        if(NOSETEST)
            add_test(
              NAME nosetests
              COMMAND nosetests3 ${CMAKE_SOURCE_DIR}/test/bindings/python/test.py
              WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test/bindings/python
            )
        else()
            message(STATUS "Nosetests could not be found - python tests not available")
        endif()
    elseif(PYTHON_SUPPORT)
        message(FATAL_ERROR "Python extension will not be built: python not found")
    endif()
else()
    message(WARNING "Python extension will not be built: cython not found")
endif()

=== debian/changelog ===
rock-master-20.06-tools-graph-analysis (0.20200505-1~buster) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-core/tools-graph_analysis.git
  * branch: refs/heads/master
  * commit: 5fdb90a56238a0ab81bc64e1419a484f29774cdc
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Mon, 07 Sep 2020 13:05:44 +0200

=== debian/control ===
Source: rock-master-20.06-tools-graph-analysis
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, cmake, coinor-cbc, coinor-clp, coinor-libcbc-dev, coinor-libclp-dev, coinor-libcoinutils-dev, coinor-libosi-dev, cython3, glpk-utils, graphviz, graphviz-dev, libboost-dev, libboost-filesystem-dev, libboost-graph-dev, libboost-iostreams-dev, libboost-program-options-dev, libboost-regex-dev, libboost-system-dev, libboost-thread-dev, libglpk-dev, libqt4-dev, libxml2-utils, libyaml-cpp-dev, python3-dev, python3-nose, qt4-qmake, rock-master-20.06-base-cmake, rock-master-20.06-base-numeric, rock-master-20.06-base-types, rock-master-20.06-external-gexf, rock-master-20.06-external-lemon, rock-master-20.06-external-snap, rock-master-20.06-utilmm
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.06-tools-graph-analysis
Architecture: any
Depends: ${shlibs:Depends}, cmake, coinor-cbc, coinor-clp, coinor-libcbc-dev, coinor-libclp-dev, coinor-libcoinutils-dev, coinor-libosi-dev, cython3, glpk-utils, graphviz, graphviz-dev, libboost-dev, libboost-filesystem-dev, libboost-graph-dev, libboost-iostreams-dev, libboost-program-options-dev, libboost-regex-dev, libboost-system-dev, libboost-thread-dev, libglpk-dev, libqt4-dev, libxml2-utils, libyaml-cpp-dev, python3-dev, python3-nose, qt4-qmake, rock-master-20.06-base-cmake, rock-master-20.06-base-numeric, rock-master-20.06-base-types, rock-master-20.06-external-gexf, rock-master-20.06-external-lemon, rock-master-20.06-external-snap, rock-master-20.06-utilmm, ruby
Description: A graph library (frontend) for modeling and analysis
 This library allows wrapping and extension of existing graph libraries for modeling and analysis.
  It provides a unified interface for boost_graph, LEMON and SNAP and comes with a graphical interface to
  create graph based GUIs.
  Additionally it contains algorithms for multi-commodity min-cost flow optimization.

=== debian/rules ===
#!/usr/bin/make -f

SHELL := /bin/bash

# BEGIN ENVIRONMENT SETUP
# https://www.debian.org/doc/debian-policy/ch-source.html
# nocheck: This tag says to not run any build-time test suite provided by the package.
DEB_BUILD_OPTIONS  = nocheck
# To disable stripping
#DEB_BUILD_OPTIONS += nostrip
export DEB_BUILD_OPTIONS

# Setup of $(arch), $(rockruby_libdir) and $(rockruby_archdir)
arch=$(shell gcc -print-multiarch)
ruby_ver=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['ruby_version']")
ruby_arch_dir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['archdir']")
ruby_libdir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['rubylibdir']")
rockruby_archdir=$(subst /usr,,$(ruby_arch_dir))
rockruby_libdir=$(subst /usr,,$(ruby_libdir))
# Setup of paths: PATH,PKG_CONFIG_PATH,RUBYLIB,...
master2006_install_dir = /opt/rock/master-20.06
env_setup =  PATH=$(master2006_install_dir)/bin:$$PATH
env_setup += HOME=/home/ 
env_setup += RUBYLIB=$(master2006_install_dir)/$(rockruby_libdir):$(master2006_install_dir)/$(rockruby_archdir):$(master2006_install_dir)/lib/ruby/vendor_ruby/standard:$(master2006_install_dir)/lib/ruby/vendor_ruby/core:$(master2006_install_dir)/lib/ruby/vendor_ruby:$$RUBYLIB
env_setup += PKG_CONFIG_PATH=$(master2006_install_dir)/lib/pkgconfig:$(master2006_install_dir)/lib/$(arch)/pkgconfig:/usr/share/pkgconfig:/usr/lib/$(arch)/pkgconfig:$$PKG_CONFIG_PATH
env_setup += Rock_DIR=$(master2006_install_dir)/share/rock/cmake:$$Rock_DIR
env_setup += LD_LIBRARY_PATH=$(master2006_install_dir)/lib:$(master2006_install_dir)/lib/$(arch):$$LD_LIBRARY_PATH
env_setup += CMAKE_PREFIX_PATH=$(master2006_install_dir):$$CMAKE_PREFIX_PATH
env_setup += OROGEN_PLUGIN_PATH=$(master2006_install_dir)/share/orogen/plugins:$$OROGEN_PLUGIN_PATH
export TYPELIB_CXX_LOADER=castxml
export DEB_CPPFLAGS_APPEND=-std=c++11
export npm_config_cache=/tmp/npm
rock_library_dirs=$(master2006_install_dir)/lib:$(master2006_install_dir)/lib/$(arch):
rock_base_install_dir=/opt/rock
rock_release_install_dir=/opt/rock/master-20.06
rock_install_dir=/opt/rock/master-20.06/rock-master-20.06-tools-graph-analysis

# Check if a python command is available and identify the version
# and identify the setup.py file
python_cmd=$(shell command -v python 2> /dev/null)
ifneq ("$(python_cmd)","")
python_version=$(shell python -c 'import sys; print "{0}.{1}".format(sys.version_info[0],sys.version_info[1])')
# Get dirname a setup.py match
python_setup_dir=$(shell find $(DEB_SRCDIR) -name setup.py | tail -n 1 | xargs dirname)
endif

DEB_VERBOSE_ALL=1
include /usr/share/cdbs/1/rules/debhelper.mk

extra_lib_dir=$(shell pwd)/debian/rock-master-20.06-tools-graph-analysis$(rock_install_dir)/lib
apaka_libdeps_dirs=`find $(rock_release_install_dir)/* -type d -name lib -exec echo -n ":{}" \;`
# This argument list is forwarded to dh_shlibdeps which takes the -l option and a colon separated list of libraries
# (note that this is different from the linker arguments)
DEB_DH_SHLIBDEPS_ARGS_ALL=-l$(extra_lib_dir):$(extra_lib_dir)/$(arch):$(rock_library_dirs):${apaka_libdeps_dirs}

debian_install_prefix=$(DEB_DESTDIR)$(rock_install_dir)
rock_doc_install_dir=$(rock_install_dir)/share
SOURCE_ENVSH=for file in `find $(rock_release_install_dir)/*/env.sh ! -empty -type f -name env.sh`; do source "$$file"; done;

pre-build::
	echo "Running pre-build"
	echo "Ruby stats"
	echo "   ruby version: $(ruby_ver)"
	echo "   ruby libdir: $(rockruby_libdir)"
	echo "   ruby archdir: $(rockruby_archdir)"
	# Source the available packages
	echo "Sourcing release packages' env.sh"

# END ENVIRONMENT SETUP
######################################
# BEGIN OROGEN -- This block needs to be executed before CMAKE


# END OROGEN
######################################
# BEGIN CMAKE
#
# Defining the cmake command and setting the required enviroment variables
# PKG_CONFIG_PATH Resolve Rock package via pkg-config
# Rock_DIR Set to make sure find_package(Rock) does work
# ROCK_CMAKE_MACROS Used in some patches to set the CMAKE_MODULE_PATH, allowing to find Rock.cmake
CMAKE = $(SOURCE_ENVSH) $(env_setup) cmake
DEB_CMAKE_INSTALL_PREFIX = $(rock_install_dir)

# Debian packaging discourages the use of rpath, but
# cdbs actively sets CMAKE_SKIP_RPATH=ON, so reinforcing OFF here
DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_SKIP_RPATH=OFF
# Telling FindGEM.cmake to search for os packages using pkg-config and not for gems
DEB_CMAKE_EXTRA_FLAGS += -DGEM_OS_PKG=TRUE
# Leaving RUBY_EXECUTABLE unset since it maps to a path of the user executing the upload script
DEB_CMAKE_EXTRA_FLAGS += -DPYTHON_EXECUTABLE="/usr/bin/python3" -DCMAKE_EXPORT_COMPILE_COMMANDS="ON" -DCMAKE_BUILD_TYPE="RelWithDebInfo" 
# Disable ROCK Testing -- since running test on the OBS would require proper setting of path, etc. (see. data_processing/type_to_vector)
DEB_CMAKE_EXTRA_FLAGS += -DROCK_TEST_ENABLED=OFF -UROCK_TEST_LOG_DIR
include /usr/share/cdbs/1/class/cmake.mk

# END CMAKE
##########################################
# BEGIN AUTOTOOLS
#


###########################################
# DOCS


# Build docs
# This checks for Doxyfile and runs doxygen with that.
# Otherwise, it tries the "doc" target.
# Since docs are not critical, ignore failures('-' on recipe line start).
# The make call is supposed to be invoked even if -t or -n is selected,
# with the appropriate flags('+' on recipe line start)

common-build-arch common-build-indep:: debian/stamp-rock-doc
debian/stamp-rock-doc:
	-+$(DEB_MAKE_INVOKE) doc
	touch $@

common-install-arch common-install-indep:: common-install-rock-doc install-extensions
common-install-rock-doc::
	mkdir -p $(DEB_DESTDIR)$(rock_doc_install_dir)
	$(if $(wildcard $(DEB_SRCDIR)/doc/html),-cp -r "$(DEB_SRCDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_SRCDIR)/doc),-cp -r "$(DEB_SRCDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))
	$(if $(wildcard $(DEB_BUILDDIR)/doc/html),-cp -r "$(DEB_BUILDDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_BUILDDIR)/doc),-cp -r "$(DEB_BUILDDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))

install-extensions:: install-python
install-python::
ifneq ("$(python_setup_dir)","")
	echo "Installing python extension in $(python_setup_dir)"
	mkdir -p $(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages
	cd $(python_setup_dir); $(python_cmd) setup.py build; PYTHONPATH=$(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages/ $(python_cmd) setup.py install --prefix=$(DEB_DESTDIR)$(rock_install_dir); cd -
endif

clean::
	rm -f debian/stamp-rock-doc
	rm -rf $(DEB_SRCDIR)/doc/html

# END DOCS
###########################################

define export_variable
	find $(debian_install_prefix) -type f -name '*$2' -exec dirname {} + | grep -v CMakeFiles | uniq | xargs -i printf "$1={}:\$${$1}\nexport $1\n" >> $(debian_install_prefix)/env.sh
	sed -i s#$(debian_install_prefix)#$(rock_install_dir)#g $(debian_install_prefix)/env.sh
	find $(debian_install_prefix) -type f -name '*$2' -exec dirname {} + | grep -v CMakeFiles | uniq | xargs -i printf "$1 {}\n" >> $(debian_install_prefix)/env.yml.append
	sed -i s#$(debian_install_prefix)#$(rock_install_dir)#g $(debian_install_prefix)/env.yml.append
endef

#install/rock-master-20.06-tools-graph-analysis::
#	echo "Running post-install for package rock-master-20.06-tools-graph-analysis"

# see https://github.com/Debian/cdbs/blob/master/1/rules/debhelper.mk.in for
# target
common-binary-fixup-arch::
	echo "Apaka: doing all the custom adaptions, once all patches have been applied"
	echo "Installing env.yml (and env.yml.append) in $(rock_install_dir)"
	$(if $(wildcard $(DEB_SRCDIR)/env.yml),-cp "$(DEB_SRCDIR)/env.yml" "$(DEB_DESTDIR)$(rock_install_dir)")
	$(if $(wildcard $(DEB_SRCDIR)/env.yml.append),-cp "$(DEB_SRCDIR)/env.yml.append" "$(DEB_DESTDIR)$(rock_install_dir)")
	echo "Updating env.sh in $(rock_install_dir)"
	$(if $(wildcard $(DEB_SRCDIR)/env.sh),-cp "$(DEB_SRCDIR)/env.sh" "$(debian_install_prefix)")
